on clickButton
  set sp to the clickOn
  set cc to the castNum of sprite the clickOn
  puppetSprite(sp, 1)
  set the castNum of sprite sp to cc + 1
  puppetSound("click")
  updateStage()
  set hilited to 1
  repeat while the mouseDown
    if hilited then
      if the mouseCast <> (cc + 1) then
        set the castNum of sprite sp to cc
        set hilited to 0
        updateStage()
      end if
      next repeat
    end if
    if the mouseCast = cc then
      set the castNum of sprite sp to cc + 1
      set hilited to 1
      updateStage()
    end if
  end repeat
  set the castNum of sprite sp to cc
  updateStage()
  return hilited
end

on tabButton
  set sp to the clickOn
  set cc to the castNum of sprite the clickOn
  puppetSprite(sp, 1)
  set the castNum of sprite sp to cc + 1
  puppetSound("tabDown")
  updateStage()
  set hilited to 1
  repeat while the mouseDown
    if hilited then
      if the mouseCast <> (cc + 1) then
        set the castNum of sprite sp to cc
        set hilited to 0
        updateStage()
      end if
      next repeat
    end if
    if the mouseCast = cc then
      set the castNum of sprite sp to cc + 1
      set hilited to 1
      updateStage()
    end if
  end repeat
  set the castNum of sprite sp to cc
  updateStage()
  puppetSprite(sp, 0)
  return hilited
end

on screenAreaButton
  set sp to the clickOn
  set cc to the castNum of sprite the clickOn
  set hilited to 1
  repeat while the mouseDown
    if hilited then
      if the mouseCast <> cc then
        set hilited to 0
        updateStage()
      end if
      next repeat
    end if
    if the mouseCast = cc then
      set hilited to 1
      updateStage()
    end if
  end repeat
  if hilited then
    puppetSound("screenButtonClick")
    updateStage()
  end if
  return hilited
end

on pushButton
  set sp to the clickOn
  set cc to the castNum of sprite the clickOn
  puppetSprite(sp, 1)
  set the castNum of sprite sp to cc + 1
  puppetSound("pushButtonSound")
  updateStage()
  set hilited to 1
  repeat while the mouseDown
    if hilited then
      if the mouseCast <> (cc + 1) then
        set the castNum of sprite sp to cc
        set hilited to 0
        updateStage()
      end if
      next repeat
    end if
    if the mouseCast = cc then
      set the castNum of sprite sp to cc + 1
      set hilited to 1
      updateStage()
    end if
  end repeat
  updateStage()
  puppetSprite(sp, 0)
  return hilited
end

on screenButton
  set sp to the clickOn
  set cc to the castNum of sprite the clickOn
  puppetSprite(sp, 1)
  set the castNum of sprite sp to cc + 1
  puppetSound("screenButtonClick")
  updateStage()
  set hilited to 1
  repeat while the mouseDown
    if hilited then
      if the mouseCast <> (cc + 1) then
        set the castNum of sprite sp to cc
        set hilited to 0
        updateStage()
      end if
      next repeat
    end if
    if the mouseCast = cc then
      set the castNum of sprite sp to cc + 1
      set hilited to 1
      updateStage()
    end if
  end repeat
  set the castNum of sprite sp to cc
  updateStage()
  puppetSprite(sp, 0)
  return hilited
end

on checkRoll rolloverSpriteList
  set nn to count(rolloverSpriteList)
  repeat with i = 1 to nn
    set sp to getAt(rolloverSpriteList, i)
    set cc to the castNum of sprite sp
    set cName to the name of cast cc
    if rollOver(sp) then
      if cName = "unRolled" then
        puppetSprite(sp, 1)
        if (sp >= 14) and (sp <= 21) then
          puppetSound("tabRoll")
        else
          if (sp >= 7) and (sp <= 9) then
            puppetSound("tabRoll")
          else
            puppetSound("note" & random(10))
          end if
        end if
        set the castNum of sprite sp to the castNum of sprite sp + 1
      end if
      next repeat
    end if
    puppetSprite(sp, 0)
  end repeat
  updateStage()
end

on checkQuitRoll rolloverSpriteList
  set nn to count(rolloverSpriteList)
  repeat with i = 1 to nn
    set sp to getAt(rolloverSpriteList, i)
    set cc to the castNum of sprite sp
    set cName to the name of cast cc
    if rollOver(sp) then
      if cName = "unRolled" then
        puppetSprite(sp, 1)
        if (sp >= 14) and (sp <= 21) then
          puppetSound("tabRoll")
        else
          if (sp >= 6) and (sp <= 9) then
            puppetSound("tabRoll")
          else
            puppetSound("note" & random(10))
          end if
        end if
        set the castNum of sprite sp to the castNum of sprite sp + 1
      end if
      next repeat
    end if
    puppetSprite(sp, 0)
  end repeat
  updateStage()
end

on checkAddonSectionRoll rolloverSpriteList
  set nn to count(rolloverSpriteList)
  repeat with i = 1 to nn
    set sp to getAt(rolloverSpriteList, i)
    set cc to the castNum of sprite sp
    set cName to the name of cast cc
    if rollOver(sp) then
      if cName = "unRolled" then
        puppetSprite(sp, 1)
        if ((sp >= 14) and (sp <= 21)) or ((sp >= 7) and (sp <= 9)) then
          puppetSound("tabRoll")
        else
          if (sp >= 7) and (sp <= 9) then
            puppetSound("tabRoll")
          else
            puppetSound("newNote" & random(9))
          end if
        end if
        set the castNum of sprite sp to the castNum of sprite sp + 1
      end if
      next repeat
    end if
    puppetSprite(sp, 0)
  end repeat
  updateStage()
end

on checkIntroRoll rolloverSpriteList
  set nn to count(rolloverSpriteList)
  repeat with i = 1 to nn
    set sp to getAt(rolloverSpriteList, i)
    set cc to the castNum of sprite sp
    set cName to the name of cast cc
    if rollOver(sp) then
      if cName = "unRolled" then
        puppetSprite(sp, 1)
        if sp = 11 then
          puppetSound("keyJangle")
        else
          if (sp >= 14) and (sp <= 21) then
            puppetSound("tabRoll")
          else
            if (sp >= 7) and (sp <= 9) then
              puppetSound("tabRoll")
            else
              puppetSound("note" & random(10))
            end if
          end if
        end if
        set the castNum of sprite sp to the castNum of sprite sp + 1
      end if
      next repeat
    end if
    puppetSprite(sp, 0)
  end repeat
  updateStage()
end

on checkTourRoll rolloverSpriteList
  set nn to count(rolloverSpriteList)
  repeat with i = 1 to nn
    set sp to getAt(rolloverSpriteList, i)
    set cc to the castNum of sprite sp
    set cName to the name of cast cc
    if rollOver(sp) then
      if cName = "unRolled" then
        puppetSprite(sp, 1)
        if sp = 11 then
          puppetSound("unlockDoor")
        else
          if (sp >= 14) and (sp <= 21) then
            puppetSound("tabRoll")
          else
            if (sp >= 7) and (sp <= 9) then
              puppetSound("tabRoll")
            else
              puppetSound("tabRoll")
            end if
          end if
        end if
        set the castNum of sprite sp to the castNum of sprite sp + 1
      end if
      next repeat
    end if
    puppetSprite(sp, 0)
  end repeat
  updateStage()
end

on checkSamplesRoll rolloverSpriteList
  set nn to count(rolloverSpriteList)
  repeat with i = 1 to nn
    set sp to getAt(rolloverSpriteList, i)
    set cc to the castNum of sprite sp
    set cName to the name of cast cc
    if rollOver(sp) then
      if cName = "unRolled" then
        puppetSprite(sp, 1)
        if sp = 11 then
          puppetSound("doorSound")
        else
          if (sp >= 14) and (sp <= 21) then
            puppetSound("tabRoll")
          else
            if sp = 23 then
              puppetSound("note1")
            else
              if sp = 24 then
                puppetSound("note2")
              else
                if sp = 25 then
                  puppetSound("note3")
                else
                  if sp = 26 then
                    puppetSound("note4")
                  else
                    if sp = 27 then
                      puppetSound("note5")
                    else
                      if sp = 28 then
                        puppetSound("note6")
                      else
                        if sp = 29 then
                          puppetSound("note7")
                        else
                          if sp = 30 then
                            puppetSound("note8")
                          else
                            if sp = 31 then
                              puppetSound("note9")
                            else
                              if sp = 32 then
                                puppetSound("note10")
                              else
                                if (sp >= 7) and (sp <= 9) then
                                  puppetSound("tabRoll")
                                else
                                  puppetSound("note" & random(10))
                                end if
                              end if
                            end if
                          end if
                        end if
                      end if
                    end if
                  end if
                end if
              end if
            end if
          end if
        end if
        set the castNum of sprite sp to the castNum of sprite sp + 1
      end if
      next repeat
    end if
    puppetSprite(sp, 0)
  end repeat
  updateStage()
end

on checkSamplesMenuRoll rolloverSpriteList
  set nn to count(rolloverSpriteList)
  repeat with i = 1 to nn
    set sp to getAt(rolloverSpriteList, i)
    set cc to the castNum of sprite sp
    set cName to the name of cast cc
    if rollOver(sp) then
      if cName = "unRolled" then
        puppetSprite(sp, 1)
        if sp = 11 then
          puppetSound("doorSound")
        else
          if (sp >= 14) and (sp <= 21) then
            puppetSound("tabRoll")
          else
            if sp = 23 then
              puppetSound("note1")
            else
              if sp = 24 then
                puppetSound("note2")
              else
                if sp = 25 then
                  puppetSound("note3")
                else
                  if sp = 26 then
                    puppetSound("note4")
                  else
                    if sp = 27 then
                      puppetSound("note5")
                    else
                      if sp = 28 then
                        puppetSound("note6")
                      else
                        if sp = 29 then
                          puppetSound("note7")
                        else
                          if sp = 30 then
                            puppetSound("note8")
                          else
                            if sp = 31 then
                              puppetSound("note9")
                            else
                              if sp = 32 then
                                puppetSound("note10")
                              else
                                if (sp >= 7) and (sp <= 9) then
                                  puppetSound("tabRoll")
                                else
                                  puppetSound("note" & random(10))
                                end if
                              end if
                            end if
                          end if
                        end if
                      end if
                    end if
                  end if
                end if
              end if
            end if
          end if
        end if
        set the castNum of sprite sp to the castNum of sprite sp + 1
      end if
      next repeat
    end if
    puppetSprite(sp, 0)
  end repeat
  updateStage()
end

on checkAddonsRoll rolloverSpriteList
  set nn to count(rolloverSpriteList)
  repeat with i = 1 to nn
    set sp to getAt(rolloverSpriteList, i)
    set cc to the castNum of sprite sp
    set cName to the name of cast cc
    if rollOver(sp) then
      if cName = "unRolled" then
        puppetSprite(sp, 1)
        if sp = 11 then
          puppetSound("cameraClick")
        else
          if (sp >= 7) and (sp <= 9) then
            puppetSound("tabRoll")
          else
            if (sp >= 14) and (sp <= 21) then
              puppetSound("tabRoll")
            else
              puppetSound("note" & random(10))
            end if
          end if
        end if
        set the castNum of sprite sp to the castNum of sprite sp + 1
      end if
      next repeat
    end if
    puppetSprite(sp, 0)
  end repeat
  updateStage()
end

on checkPopupRoll rolloverSprite, hiliteRectList, hiliteCastList
  set sp to rolloverSprite
  set hiliteSprite to rolloverSprite + 1
  set cc to the castNum of sprite sp
  set cName to the name of cast cc
  if rollOver(sp) or rollOver(hiliteSprite) then
    if cName = "unrolled" then
      puppetSprite(sp, 1)
      puppetSprite(hiliteSprite, 1)
      puppetSound("popupRollover")
      set the castNum of sprite sp to the castNum of sprite sp + 1
    else
      if checkRollPopupHilites(hiliteSprite, hiliteRectList, hiliteCastList) then
        updateStage()
      else
      end if
    end if
  else
    puppetSprite(sp, 0)
    puppetSprite(hiliteSprite, 0)
  end if
  updateStage()
end

on checkRollPopupHilites hiliteSprite, hiliteRectList, hiliteCastList
  set cc to count(hiliteRectList)
  set rollSprite to hiliteSprite - 1
  repeat with i = 1 to cc
    if mouseInRect(getAt(hiliteRectList, i)) then
      set hCast to getAt(hiliteCastList, i)
      if the castNum of sprite hiliteSprite <> hCast then
        set the castNum of sprite hiliteSprite to hCast
        set the locH of sprite hiliteSprite to the locH of sprite rollSprite
        set the locV of sprite hiliteSprite to the locV of sprite rollSprite
        puppetSound("popupRollover")
      end if
      return 1
    end if
  end repeat
  return 0
end

on hidePopup whichSprite
  set cc to the castNum of sprite whichSprite
  set cName to the name of cast cc
  if cName = "rolled" then
    set saveH to the locH of sprite (whichSprite + 1)
    set the locH of sprite (whichSprite + 1) to -10000
    updateStage()
    scriptDelay(5)
    set the locH of sprite (whichSprite + 1) to saveH
    updateStage()
    scriptDelay(5)
    set the locH of sprite (whichSprite + 1) to -10000
    updateStage()
    scriptDelay(5)
    set the locH of sprite (whichSprite + 1) to saveH
    updateStage()
    scriptDelay(5)
    set the castNum of sprite whichSprite to the castNum of sprite whichSprite - 1
    set the locH of sprite (whichSprite + 1) to -10000
    updateStage()
  end if
  puppetSprite(whichSprite, 0)
  puppetSprite(whichSprite + 1, 0)
  updateStage()
end

on mouseInRect whichRect
  return (the mouseH >= the left of whichRect) and (the mouseH <= the right of whichRect) and (the mouseV >= the top of whichRect) and (the mouseV <= the bottom of whichRect)
end

on popUpMenu pixelsPerRow, hiliteSprite, choiceList, menuRect
  set numChoices to count(choiceList)
  set sp to the clickOn
  set cc to the castNum of sprite the clickOn
  set hlCast to the castNum of sprite hiliteSprite
  set the castNum of sprite sp to cc + 1
  puppetSound("menuAppears")
  updateStage()
  set hilited to 1
  set bNum to 0
  repeat while the mouseDown
    if hilited then
      if (the mouseCast <> (cc + 1)) and (the mouseCast <> hlCast) then
        scriptDelay(3)
        if (the mouseCast <> (cc + 1)) and (the mouseCast <> hlCast) then
          set the castNum of sprite sp to cc
          set the rect of sprite hiliteSprite to rect(0, 0, 0, 0)
          set bNum to 0
          set hilited to 0
          updateStage()
        end if
      else
        set mTop to the top of menuRect
        set vv to the mouseV
        set dd to vv - mTop
        set bNum to (dd / pixelsPerRow) + 1
        if bNum <= numChoices then
          set ll to the left of menuRect
          set rr to the right of menuRect
          set tt to mTop + (pixelsPerRow * (bNum - 1))
          set bb to tt + pixelsPerRow + 1
          set the rect of sprite hiliteSprite to rect(ll, tt, rr, bb)
          set the blend of sprite hiliteSprite to 50
        else
          set bNum to 0
          set the rect of sprite hiliteSprite to rect(0, 0, 0, 0)
        end if
        updateStage()
      end if
      next repeat
    end if
    if the mouseCast = cc then
      set the castNum of sprite sp to cc + 1
      set hilited to 1
      updateStage()
    end if
  end repeat
  if bNum then
    puppetSound("popupSelectionMade")
    set the visible of sprite hiliteSprite to 0
    updateStage()
    realDelay(3)
    set the visible of sprite hiliteSprite to 1
    updateStage()
    realDelay(5)
    set the visible of sprite hiliteSprite to 0
    updateStage()
    realDelay(3)
    set the visible of sprite hiliteSprite to 1
    updateStage()
    realDelay(5)
    set the visible of sprite hiliteSprite to 0
    updateStage()
    realDelay(3)
    set the visible of sprite hiliteSprite to 1
    updateStage()
    realDelay(5)
  end if
  hideSprite(hiliteSprite)
  set the castNum of sprite sp to cc
  updateStage()
  if bNum then
    return getAt(choiceList, bNum)
  else
    return bNum
  end if
end

on scriptDelay x
  set tt to the ticks
  repeat while the ticks < (tt + x)
    if the mouseDown then
      repeat while the mouseDown
      end repeat
      exit
    end if
  end repeat
end

on realDelay x
  set the keyDownScript to "blockKeys"
  set tt to the ticks
  repeat while the ticks < (tt + x)
  end repeat
  set the keyDownScript to EMPTY
end

on hideSprite whichSprite
  set the locH of sprite whichSprite to -2000
end
